<template>
  <div :style="{ 'margin-left': `20px` }" class="tree">
    <span
      v-if="node.children && node.children.length > 0"
      @click="expanded = !expanded"
      class="type"
    >
      {{ expanded ? "&#9660;" : "&#9658;" }}
    </span>

    <input
      type="checkbox"
      :indeterminate.prop="node.indeterminate"
      v-model="node.checked"
      @change="changeNodeSelection($event.target.checked, node)"
    />

    {{ node.name }}

    <input
      type="number"
      class="number"
      v-if="node.countable"
      v-model="node.count"
      min="0"
      @change="changeNodeCount($event.target.value, node)"
    />

    <input
      type="color"
      class="color"
      v-if="node.colorable"
      v-model="node.color"
      @change="changeNodeColor($event.target.value, node)"
    />

    <div class="wrapper" v-if="expanded">
      <Tree
        v-for="child in forTree"
        :key="child.name"
        :node="child"
        :depth="depth + 1"
        :parent="child.id"
      />
    </div>
  </div>
</template>

<script>
export default {
  name: "Tree",
  props: {
    parent: Number,
    node: Object,
    depth: {
      type: Number,
      default: 0,
    },
  },
  data: function () {
    return {
      expanded: false,
    };
  },
  computed: {
    forTree() {
      var parsedobj = JSON.parse(JSON.stringify(this.node));
      return parsedobj.children;
    },
  },
  methods: {
    changeNodeSelection(checked, menuItem) {
      menuItem.checked = checked;
      this.$store.dispatch("nodeSelection", menuItem);
    },
    changeNodeCount(value, menuItem) {
      menuItem.count = value;
      this.$store.dispatch("nodeCountChanged", menuItem);
    },
    changeNodeColor(value, menuItem) {
      menuItem.color = value;
      this.$store.dispatch("nodeColorChanged", menuItem);
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.tree {
  text-align: left;
  font-size: 25x;
}
.number {
  width: 35px;
}
.color {
  width: 35px;
  margin-left: 5px;
}
</style>
